"use strict";

exports.__esModule = true;
exports.config = config;
exports.getOffset = getOffset;
exports.pushElement = pushElement;
exports.default = void 0;
var offsetTop = 0;
var appearEvt, disappearEvt;
var _appearDoms = [];

var AppearRegistry =
/*#__PURE__*/
function () {
  AppearRegistry.createEvent = function createEvent() {
    appearEvt = document.createEvent('HTMLEvents');
    disappearEvt = document.createEvent('HTMLEvents');
    appearEvt.initEvent('appear', false, true);
    disappearEvt.initEvent('disappear', false, true);
  };

  function AppearRegistry(elements) {
    this.current = [];
    this.elements = elements;
    this.options = {
      container: window,
      wait: 100,
      x: 0,
      y: 0,
      cls: 'appear',
      once: false,
      onReset: function onReset() {},
      onAppear: function onAppear() {},
      onDisappear: function onDisappear() {}
    };
    this.container = null;
    this.appearWatchElements = null;
    this.initConfig.apply(this, arguments);
  }

  var _proto = AppearRegistry.prototype;

  _proto.initConfig = function initConfig(opts) {
    this.extend(this.options, opts || (opts = {}));
    this.appearWatchElements = this.appearWatchElements || this.getElements();
    this.bindEvent();
  };

  _proto.extend = function extend(target, el) {
    for (var k in el) {
      if (el.hasOwnProperty(k)) {
        target[k] = el[k];
      }
    }

    return target;
  };

  _proto.inViewport = function inViewport(element, offset, type) {
    var _element$getBoundingC = element.getBoundingClientRect(),
        top = _element$getBoundingC.top,
        right = _element$getBoundingC.right,
        bottom = _element$getBoundingC.bottom,
        left = _element$getBoundingC.left;

    left = offset.right > left && offset.left < right;
    top = offset.bottom > top - offsetTop && offset.top < bottom;
    return left && top;
  };

  _proto.getElements = function getElements(type) {
    var container = this.options.container;
    var appearWatchElements;
    this.container = container;
    appearWatchElements = _appearDoms || [];
    appearWatchElements = [].slice.call(appearWatchElements, null);
    return appearWatchElements;
  } // check dom inview
  ;

  _proto.check = function check(nodes) {
    var _this = this;

    raf(function () {
      _this.calculate(nodes);
    });
  } // calculate everyone dom inview
  ;

  _proto.calculate = function calculate(nodes) {
    var _this2 = this;

    var container = this.container;
    var elements = nodes || this.getElements();
    var containerOffset = getOffset(window, {
      x: this.options.x,
      y: this.options.y
    });
    var isOnce = this.options.once;
    var ev = arguments[0] || {};

    if (!container) {
      return;
    }

    if (elements && elements.length > 0) {
      [].forEach.call(elements, function (ele, i) {
        if (ele) {
          if (ele.isOnce && ele._hasAppear) {
            _appearDoms.splice(i, 1);

            elements.splice(i, 1);
            return;
          }

          _this2.checkEveryDom(ele, containerOffset, isOnce, appearEvt, disappearEvt, 'normal', i);
        }
      });
    }
  };

  _proto.checkEveryDom = function checkEveryDom(ele, containerOffset, isOnce, cacheAppearEvt, cacheDisappearEvt, type, pos) {
    var eleOffset = getOffset(ele);
    var direction = this.getDirection(ele._eleOffset, eleOffset);
    var isInView = this.inViewport(ele, containerOffset, type);
    var appear = ele._appear;
    var _hasAppear = ele._hasAppear;
    var _hasDisAppear = ele._hasDisAppear;
    ele._eleOffset = eleOffset;
    cacheAppearEvt.direction = direction;
    cacheDisappearEvt.direction = direction;

    if (isInView && !appear) {
      if (isOnce && !_hasAppear || !isOnce) {
        ele.dispatchEvent(cacheAppearEvt);
        ele._hasAppear = true;
        ele._appear = true;
      }
    } else if (!isInView && appear) {
      if (isOnce && !_hasDisAppear || !isOnce) {
        ele.dispatchEvent(cacheDisappearEvt);
        ele._hasDisAppear = true;
        ele._appear = false;
      }
    }
  } // reset
  ;

  _proto.reset = function reset(opts) {
    this.initConfig(opts);
    this.appearWatchElements.forEach(function (ele) {
      delete ele._hasAppear;
      delete ele._hasDisAppear;
      delete ele._appear;
    });
    return this;
  };

  _proto.bindEvent = function bindEvent() {
    var _this3 = this;

    var handle = throttle(function () {
      _this3.check();
    }, this.options.wait);

    if (this.__handle) {
      this.container.removeEventListener('scroll', this.__handle, false, true);
      this.__handle = null;
    }

    this.__handle = handle;
    this.container.addEventListener('scroll', handle, false, true);
  };

  _proto.getDirection = function getDirection(beforeOffset, nowOffset) {
    var direction = 'none';
    var horizental = beforeOffset.left - nowOffset.left;
    var vertical = beforeOffset.top - nowOffset.top;

    if (vertical == 0) {
      if (horizental != 0) {
        direction = horizental > 0 ? 'left' : 'right';
      } else {
        direction = 'none';
      }
    }

    if (horizental == 0) {
      if (vertical != 0) {
        direction = vertical > 0 ? 'up' : 'down';
      } else {
        direction = 'none';
      }
    }

    return direction;
  };

  return AppearRegistry;
}();

var raf = window.requestAnimationFrame || window.webkitRequestAnimationFrame || function (c) {
  setTimeout(c, 1 / 60 * 1e3);
};

function throttle(fn, wait) {
  var context, args, result;
  var timeout = null;
  var previous = 0;

  var later = function later() {
    previous = Date.now();
    timeout = null;
    result = fn.apply(context, args);
  };

  return function () {
    var now = Date.now();
    var remaining = wait - (now - previous);
    context = this;
    args = arguments;

    if (remaining <= 0) {
      clearTimeout(timeout);
      timeout = null;
      previous = now;
      result = fn.apply(context, args);
    } else if (!timeout) {
      timeout = setTimeout(later, remaining);
    }

    return result;
  };
}

function config(opts) {
  if (opts.offsetTop && typeof opts.offsetTop === 'number') {
    offsetTop = opts.offsetTop;
  }
}

function getOffset(el, param) {
  var l, r, b, t;

  if (!el) {
    return;
  }

  if (!param) {
    param = {
      x: 0,
      y: 0
    };
  }

  if (el === window) {
    l = 0;
    t = 0;
    r = l + el.innerWidth;
    b = t + el.innerHeight;
  } else if (el.parentNode === null) {
    l = 0;
    t = 0;
    r = 0;
    b = 0;
  } else {
    var _el$getBoundingClient = el.getBoundingClientRect(),
        top = _el$getBoundingClient.top,
        right = _el$getBoundingClient.right,
        bottom = _el$getBoundingClient.bottom,
        left = _el$getBoundingClient.left;

    l = left;
    t = top;
    r = right;
    b = bottom;
  }

  return {
    'left': l,
    'top': t,
    'right': r + param.x,
    'bottom': b + param.y
  };
} // add element


function pushElement(node) {
  if (_appearDoms.indexOf(node) === -1 && !node.appended) {
    var isOnce = Boolean(node.getAttribute('isonce')) || Boolean(node.getAttribute('data-once'));
    node.isOnce = isOnce;
    node.appended = true;

    _appearDoms.push(node);

    node._eleOffset = getOffset(node);
  }
}

var _default = AppearRegistry;
exports.default = _default;