"use strict";

exports.__esModule = true;
exports.setupAppear = setupAppear;

var _appearRegistry = _interopRequireWildcard(require("./appearRegistry"));

var _intersectionObserverManager = _interopRequireWildcard(require("./intersectionObserverManager"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/**
 * Simulate appear & disappear events.
 */
var instance = null;
var existIntersection = (0, _intersectionObserverManager.isExistIntersection)(); // hijack addEventListener、removeEventListener

var injectEventListenerHook = function injectEventListenerHook(instances, Node) {
  if (instances === void 0) {
    instances = [];
  }

  var nativeAddEventListener = Node.prototype.addEventListener;
  var nativeRemoveEventListener = Node.prototype.removeEventListener;

  Node.prototype.addEventListener = function (eventName, eventHandler, useCapture, doNotWatch) {
    var lowerCaseEventName = eventName && String(eventName).toLowerCase();
    var isAppearEvent = lowerCaseEventName === 'appear' || lowerCaseEventName === 'disappear';

    if (isAppearEvent) {
      if (existIntersection) {
        (0, _intersectionObserverManager.observerElement)(this);
      } else {
        (0, _appearRegistry.pushElement)(this);
      }
    }

    if (!existIntersection) {
      if (instance && isAppearEvent) {
        instance.check([this]);
      }

      if (lowerCaseEventName === 'scroll' && !doNotWatch) {
        instance = new _appearRegistry.default({
          container: this
        });
        instances.push(instance);
      }
    }

    nativeAddEventListener.call(this, eventName, eventHandler, useCapture);
  };

  Node.prototype.removeEventListener = function (eventName, eventHandler, useCapture, doNotWatch) {
    var _this = this;

    var lowerCaseEventName = eventName && String(eventName).toLowerCase();
    ; // destroy scroller

    if (!existIntersection && lowerCaseEventName === 'scroll' && !doNotWatch) {
      instances.forEach(function (instance, index) {
        if (instance.__handle && instance.container === _this) {
          _this.removeEventListener('scroll', instance.__handle, false, true);

          instance.__handle = null;
          instance.appearWatchElements = [];
          instance.container = null;
          instances.splice(index, 1);
        }
      });
    }

    nativeRemoveEventListener.call(this, eventName, eventHandler, useCapture);
  };
};

function setupAppear(win) {
  if (win === void 0) {
    win = window;
  }

  if (existIntersection) {
    (0, _intersectionObserverManager.default)();
    injectEventListenerHook([], win.Node);
  } else {
    var instances = [];

    _appearRegistry.default.createEvent();

    injectEventListenerHook(instances, win.Node);
    instance = new _appearRegistry.default({
      container: win
    });
    instances.push(instance);
    var control = {
      config: _appearRegistry.config
    };
    return control;
  }
}