"use strict";

exports.__esModule = true;
exports.observerElement = observerElement;
exports.isExistIntersection = isExistIntersection;
exports.default = createIntersectionObserver;
var options = {
  root: null,
  rootMargin: '0px',
  threshold: 0.0
};
var appearEvt, disappearEvt;
var intersectionObserver;

function initIntersection() {
  appearEvt = document.createEvent('HTMLEvents');
  disappearEvt = document.createEvent('HTMLEvents');
  appearEvt.initEvent('appear', false, true);
  disappearEvt.initEvent('disappear', false, true);
  intersectionObserver = new IntersectionObserver(handleIntersect, options);
}

function handleIntersect(entries) {
  entries.forEach(function (entry) {
    var target = entry.target,
        boundingClientRect = entry.boundingClientRect,
        intersectionRatio = entry.intersectionRatio; // is inview

    if (intersectionRatio > 0) {
      target.dataset.appeared = true;
      target.dispatchEvent(appearEvt);
    } else if (target.dataset.appeared) {
      target.dataset.appeared = false;
      target.dispatchEvent(disappearEvt);
    }
  });
}

function observerElement(element) {
  if (element === document) {
    element = document.documentElement;
  }

  intersectionObserver.observe(element);
}

function isExistIntersection() {
  return typeof IntersectionObserver === 'function';
}

function createIntersectionObserver() {
  initIntersection();
}